// server.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#define DEFAULT_BUFLEN 512
#define DEFAULT_PORT 27015

struct sockaddr_in sadr = {AF_INET, 27015, {0,0,0,0} };
struct sockaddr_in cadr;
int cadr_length = sizeof(struct sockaddr_in);

int __cdecl main(void) 
{
    WSADATA wsaData;
    int iResult;
	int iSendResult;

    SOCKET ListenSocket = INVALID_SOCKET;
    SOCKET ClientSocket = INVALID_SOCKET;

	sadr.sin_port = ntohs(DEFAULT_PORT);

    char recvbuf[DEFAULT_BUFLEN] = "";
    int recvbuflen = DEFAULT_BUFLEN;
    
    // Initialize Winsock
	
	printf("Start of initialization:\n");

    iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
    if (iResult != 0) {
        printf("WSAStartup failed with error: %d\n", iResult);
        return 1;
    }
	printf("...WSAStartup completed\n");

    // Create a SOCKET for connecting to server
    ListenSocket = socket(AF_INET, SOCK_STREAM , IPPROTO_TCP);
    if (ListenSocket == INVALID_SOCKET) {
        printf("socket failed with error: %ld\n", WSAGetLastError());
        WSACleanup();
        return 1;
    }
	printf("...Socket created succesfully\n");

    // Setup the TCP listening socket
    iResult = bind( ListenSocket, (struct sockaddr *)&sadr, sizeof(struct sockaddr_in));
    if (iResult == SOCKET_ERROR) {
        printf("bind failed with error: %d\n", WSAGetLastError());
        closesocket(ListenSocket);
        WSACleanup();
        return 1;
    }
	printf("...Bind completed\n");

    iResult = listen(ListenSocket, SOMAXCONN);
    if (iResult == SOCKET_ERROR) {
        printf("listen failed with error: %d\n", WSAGetLastError());
        closesocket(ListenSocket);
        WSACleanup();
        return 1;
    }

	printf("Initialization completed, now listening...\n");

    // listening loop
	while(strcmp(recvbuf,"QUIT")) {
		// Accept a client socket
		ClientSocket = accept(ListenSocket, NULL, NULL);
		if (ClientSocket == INVALID_SOCKET) {
			printf("accept failed with error: %d\n", WSAGetLastError());
			closesocket(ListenSocket);
			WSACleanup();
			return 1;
		}
		getpeername(ClientSocket,(struct sockaddr*)&cadr,&cadr_length);

    	// Receive until the peer shuts down the connection
		do {

			iResult = recv(ClientSocket, recvbuf, recvbuflen, 0);
			if (iResult > 0) {

				recvbuf[iResult] = 0;
				printf("Connection from: %s:%d\n",inet_ntoa(cadr.sin_addr),ntohs(cadr.sin_port));
				printf("  Bytes received: %d\n", iResult);
				printf("  Content: %s\n", recvbuf);

				// Echo the buffer back to the sender
				iSendResult = send( ClientSocket, recvbuf, iResult, 0 );
				if (iSendResult == SOCKET_ERROR) {
					printf("send failed with error: %d\n", WSAGetLastError());
					closesocket(ClientSocket);
					WSACleanup();
					return 1;
				}
				printf("  Bytes sent: %d\n", iSendResult);
			}
			else if (iResult == 0)
				printf("Connection closing...\n");
			else  {
				printf("recv failed with error: %d\n", WSAGetLastError());
				closesocket(ClientSocket);
				WSACleanup();
				return 1;
			}

		} while (iResult > 0);

		// shutdown the connection since we're done
		iResult = shutdown(ClientSocket, SD_SEND);
		if (iResult == SOCKET_ERROR) {
			printf("shutdown failed with error: %d\n", WSAGetLastError());
			closesocket(ClientSocket);
			WSACleanup();
			return 1;
		}

		// cleanup
		closesocket(ClientSocket);
	}

	printf("Exit due to QUIT command\n");

	closesocket(ListenSocket);
    WSACleanup();

    return 0;
}
